/***************************************************************************
*                 _                                _                       *
*                /_\         Chess Board          /_\                      *
*                \_/      -------------------     \_/                      *
*                /_\             Move             /_\                      *
*                |_|      -------------------     |_|                      *
*               /___\      GNU GPL Version 2     /___\                     *
*                                                                          *
***************************************************************************/
/* Header Files */
#include "move.h"
/* Window */
static WINDOW *winF;
static WINDOW *winE;
/* File Open */
FILE *gnuchess;
/* Computer Move */
const char *cmove = ". ";
const char *emove = ". ... ";
/* Definitions */
Network network;
Network network2;
/* Constructor */
Modul::Modul() {}

//-----------------------------------------------------------------------------

void Modul::cbengine(char *nmove, char *chess)
{
	/* Window Box */
	attrset(use_default_colors());
	winF = newwin(11,76,13,2);
	box(winF,ACS_VLINE,ACS_HLINE);
	winE = newwin(9,74,14,3);
	scrollok(winE,true);
	/* File Open */
	gnuchess=fopen("/var/log/cboard/engine","r+");
	/* Computer */
	while(fread(position,1, sizeof(position),gnuchess))
	{	
		if(chess[2])
		{
			bmove = strstr(position,cmove);
			sscanf(bmove,". %s",nmove);
		}
		if(chess[1])
		{
			bmove = strstr(position,emove);
			sscanf(bmove,". ... %s",nmove);
		}
		wprintw(winE,"%s", position);
	}
	/* Windows Refresh */
	touchwin(stdscr);
	refresh();
	wrefresh(winF);
	wrefresh(winE);
}

//-----------------------------------------------------------------------------

/* TCP Network / send() / recv() */		
void Modul::cbnetwork(char *nmove, char *chess,char *player,char control)
{		
	/* Time and Round */
	if(control)
	{
		wtime.time = 7200;
		btime.time = 7200;
		etime.round = 0;
		etime.round++;	
	}
	
	/* Time Control */
	control = false;
	etime.start=time(NULL);	
	move(4,37);

	/* White */
	if(chess[1])
	{
		if(player[1])
		{
			printw("W:");
			getnstr(nmove, MOV);
		}	
	}
	/* Black */
	else if(chess[2])
	{
		if(player[8])
		{
			printw("B:");
			getnstr(nmove, MOV);
		}	
	}
	/* White or Black */
	else if(chess[3])
	{
		if(player[1])
		{
			printw("W:");
			getnstr(nmove, MOV);
		}
		else if(player[8])
		{
			printw("B:");
			getnstr(nmove, MOV);
		}	
	}
	/* Server */
	else if(chess[4])
	{
		if(player[1])
		{	
			printw("W:");
			getnstr(nmove, MOV);
			network2.send(nmove, MOV);
		}
		else if(player[8])
		{
			network2.recv(nmove, MOV);
		}
	}
	/* Client */
	else if(chess[5])
	{
		if(player[1])
		{
			network.recv(nmove, MOV);	
		}
		else if(player[8])
		{	
			printw("B:");
			getnstr(nmove, MOV);	
			network.send(nmove, MOV);
		}
	}

	/* Time Control */
	etime.diff = difftime(etime.stop=time(NULL),etime.start);

	//-------------------------------------------------------------

	/* Show Move Message */
	mvhline(0,0,ACS_HLINE,82);
	mvhline(2,0,ACS_HLINE,82);
	move(1,1);
		
	if(player[1])
	{		
		wtime.time -= etime.diff;
		wtime.horas = ((wtime.time / 60) / 60);
		wtime.minutes = ((wtime.time / 60) % 60);
		wtime.seconds = (wtime.time % 60);
	}
	else if(player[8])
	{
		btime.time -= etime.diff;
		btime.horas = ((btime.time / 60) / 60);
		btime.minutes = ((btime.time / 60) % 60);
		btime.seconds = (btime.time % 60);
	}

	/* Time Message */
	printw("  %02d:%02d:%02d",wtime.horas,wtime.minutes,wtime.seconds);
	printw("\t\t %02d:%02d:%02d",btime.horas,btime.minutes,btime.seconds);
}

//-----------------------------------------------------------------------------

